#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  gui.py
#  
#  Copyright 2014 Unknown <birk@antergos>
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#  
#  

#--- Import modules

import matplotlib.pyplot as plt

from pylab import *

from skimage import morphology, filters, exposure, img_as_float
from skimage.morphology import convex_hull_image, disk
from skimage.filters import threshold_otsu
from skimage import exposure
from skimage import feature

from skimage.filters.rank import median

import tkinter as tk
from tkinter.filedialog import askopenfilename,askdirectory
from tkinter import *

import nosetrackerv1 as nt
import centroid_track as ct
import nosetracker_config as ntc

import scipy

import glob
import os
import time
import shutil
import pickle

#------------------------------------------------------------

pcrop = []
noseposition = []
queueposition = 1
moreFrames = 0
newnose = 0

def START():
	##### Master button, starts the calcualtions #####
	GGlobaltime = time.time()
	#activate buttons
	b5.configure(relief=RAISED)

	#calculate for all queuepositions
	if queueposition == 1:
		print("Add something to the Queue!")
	if queueposition >= 2:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 2
		nt.wurmstart(Q1[0],Q1[1],Q1[2],Q1[3],Q1[4],Q1[5],Q1[6],Q1[7],Q1[8],GGlobaltime,queueposition,c_queueposition,Q1[10],Q1[11])
	if queueposition >= 3:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 3
		nt.wurmstart(Q2[0],Q2[1],Q2[2],Q2[3],Q2[4],Q2[5],Q2[6],Q2[7],Q2[8],GGlobaltime,queueposition,c_queueposition,Q2[10],Q2[11])
	if queueposition >= 4:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 4
		nt.wurmstart(Q3[0],Q3[1],Q3[2],Q3[3],Q3[4],Q3[5],Q3[6],Q3[7],Q3[8],GGlobaltime,queueposition,c_queueposition,Q3[10],Q3[11])
	if queueposition >= 5:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 5
		nt.wurmstart(Q4[0],Q4[1],Q4[2],Q4[3],Q4[4],Q4[5],Q4[6],Q4[7],Q4[8],GGlobaltime,queueposition,c_queueposition,Q4[10],Q4[11])
	if queueposition >= 6:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 6
		nt.wurmstart(Q5[0],Q5[1],Q5[2],Q5[3],Q5[4],Q5[5],Q5[6],Q5[7],Q5[8],GGlobaltime,queueposition,c_queueposition,Q5[10],Q5[11])
	if queueposition >= 7:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 7
		nt.wurmstart(Q6[0],Q6[1],Q6[2],Q6[3],Q6[4],Q6[5],Q6[6],Q6[7],Q6[8],GGlobaltime,queueposition,c_queueposition,Q6[10],Q6[11])
	if queueposition >= 8:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 8
		nt.wurmstart(Q7[0],Q7[1],Q7[2],Q7[3],Q7[4],Q7[5],Q7[6],Q7[7],Q7[8],GGlobaltime,queueposition,c_queueposition,Q7[10],Q7[11])
	if queueposition >= 9:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 9
		nt.wurmstart(Q8[0],Q8[1],Q8[2],Q8[3],Q8[4],Q8[5],Q8[6],Q8[7],Q8[8],GGlobaltime,queueposition,c_queueposition,Q8[10],Q8[11])
	if queueposition >= 10:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 10
		nt.wurmstart(Q9[0],Q9[1],Q9[2],Q9[3],Q9[4],Q9[5],Q9[6],Q9[7],Q9[8],GGlobaltime,queueposition,c_queueposition,Q9[10],Q9[11])
	if queueposition >= 11:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 11
		nt.wurmstart(Q10[0],Q10[1],Q10[2],Q10[3],Q10[4],Q10[5],Q10[6],Q10[7],Q10[8],GGlobaltime,queueposition,c_queueposition,Q10[10],Q10[11])
	if queueposition >= 12:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 12
		nt.wurmstart(Q11[0],Q11[1],Q11[2],Q11[3],Q11[4],Q11[5],Q11[6],Q11[7],Q11[8],GGlobaltime,queueposition,c_queueposition,Q11[10],Q11[11])
	if queueposition >= 13:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 13
		nt.wurmstart(Q12[0],Q12[1],Q12[2],Q12[3],Q12[4],Q12[5],Q12[6],Q12[7],Q12[8],GGlobaltime,queueposition,c_queueposition,Q12[10],Q12[11])
	if queueposition >= 14:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 14
		nt.wurmstart(Q13[0],Q13[1],Q13[2],Q13[3],Q13[4],Q13[5],Q13[6],Q13[7],Q13[8],GGlobaltime,queueposition,c_queueposition,Q13[10],Q13[11])
	if queueposition >= 15:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 15
		nt.wurmstart(Q14[0],Q14[1],Q14[2],Q14[3],Q14[4],Q14[5],Q14[6],Q14[7],Q14[8],GGlobaltime,queueposition,c_queueposition,Q14[10],Q14[11])
	if queueposition >= 16:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 16
		nt.wurmstart(Q15[0],Q15[1],Q15[2],Q15[3],Q15[4],Q15[5],Q15[6],Q15[7],Q15[8],GGlobaltime,queueposition,c_queueposition,Q15[10],Q15[11])
	if queueposition >= 17:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 17
		nt.wurmstart(Q16[0],Q16[1],Q16[2],Q16[3],Q16[4],Q16[5],Q16[6],Q16[7],Q16[8],GGlobaltime,queueposition,c_queueposition,Q16[10],Q16[11])
	if queueposition >= 18:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 18
		nt.wurmstart(Q17[0],Q17[1],Q17[2],Q17[3],Q17[4],Q17[5],Q17[6],Q17[7],Q17[8],GGlobaltime,queueposition,c_queueposition,Q17[10],Q17[11])
	if queueposition >= 19:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 19
		nt.wurmstart(Q18[0],Q18[1],Q18[2],Q18[3],Q18[4],Q18[5],Q18[6],Q18[7],Q18[8],GGlobaltime,queueposition,c_queueposition,Q18[10],Q18[11])
	if queueposition >= 20:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 20
		nt.wurmstart(Q19[0],Q19[1],Q19[2],Q19[3],Q19[4],Q19[5],Q19[6],Q19[7],Q19[8],GGlobaltime,queueposition,c_queueposition,Q19[10],Q19[11])
	if queueposition >= 21:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 3
		nt.wurmstart(Q20[0],Q20[1],Q20[2],Q20[3],Q20[4],Q20[5],Q20[6],Q20[7],Q20[8],GGlobaltime,queueposition,c_queueposition,Q20[10],Q20[11])
	
def getdir():
	##### Gets the working directory #####
	global directory
	global name
	global filecount
	global isimport
	global bestedge
	global completeedge
	global pcrop
	global Gfirstframe
	global Glastframe
	global Gblocksize
	global Gwormsize
	global startnoseposition
	global newdirectory
	
	#set initial directory and file for crop
	name = askopenfilename(initialdir=ntc.start_directory,filetypes=[("pics and settings",("*.tif","*.p")),("all files","*")])
	directory = os.path.dirname(name)
	
	#---check if image or conf file was loaded
	if name[-2:] == ".p":
		isimport = 1
		print("settings loaded")
		#set all buttons to finished working state
		b2.configure(state=NORMAL)
		b5.configure(state=NORMAL)
		b5.configure(relief=SUNKEN)
		b6.configure(state=NORMAL)
		b7.configure(state=NORMAL)
		b8.configure(state=NORMAL) #show crop
		b9.configure(state=NORMAL) #manual nose
		b9.configure(relief=SUNKEN)#manual nose
		b10.configure(state=NORMAL)#enqueue
		
		#delete content of entry boxes
		e1.delete(0,END)
		e2.delete(0,END)
		e3.delete(0,END)
		e4.delete(0,END)
		e6.delete(0,END)
		e7.delete(0,END)
		
		if queueposition == 1:
			Q1 = pickle.load(open(name,"rb"))
			#name = Q1[9] #filename
			e1.insert(0,Q1[4]) #blocksize
			e2.insert(0,Q1[0]) #startframe
			e3.insert(0,Q1[1]) #stopframe
			e4.insert(0,Q1[6]) #wormsize
			e6.insert(0,Q1[10]) #px size
			e7.insert(0,Q1[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q1
		elif queueposition == 2:
			Q2 = pickle.load(open(name,"rb"))
			name = Q2[9] #filename
			e1.insert(0,Q2[4]) #blocksize
			e2.insert(0,Q2[0]) #startframe
			e3.insert(0,Q2[1]) #stopframe
			e4.insert(0,Q2[6]) #wormsize
			e6.insert(0,Q2[10]) #px size
			e7.insert(0,Q2[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q2
		elif queueposition == 3:
			Q3 = pickle.load(open(name,"rb"))
			name = Q3[9] #filename
			e1.insert(0,Q3[4]) #blocksize
			e2.insert(0,Q3[0]) #startframe
			e3.insert(0,Q3[1]) #stopframe
			e4.insert(0,Q3[6]) #wormsize
			e6.insert(0,Q3[10]) #px size
			e7.insert(0,Q3[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q3
		elif queueposition == 4:
			Q4 = pickle.load(open(name,"rb"))
			name = Q4[9] #filename
			e1.insert(0,Q4[4]) #blocksize
			e2.insert(0,Q4[0]) #startframe
			e3.insert(0,Q4[1]) #stopframe
			e4.insert(0,Q4[6]) #wormsize
			e6.insert(0,Q4[10]) #px size
			e7.insert(0,Q4[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q4
		elif queueposition == 5:
			Q5 = pickle.load(open(name,"rb"))
			name = Q5[9] #filename
			e1.insert(0,Q5[4]) #blocksize
			e2.insert(0,Q5[0]) #startframe
			e3.insert(0,Q5[1]) #stopframe
			e4.insert(0,Q5[6]) #wormsize
			e6.insert(0,Q5[10]) #px size
			e7.insert(0,Q5[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q5
		elif queueposition == 6:
			Q6 = pickle.load(open(name,"rb"))
			name = Q6[9] #filename
			e1.insert(0,Q6[4]) #blocksize
			e2.insert(0,Q6[0]) #startframe
			e3.insert(0,Q6[1]) #stopframe
			e4.insert(0,Q6[6]) #wormsize
			e6.insert(0,Q6[10]) #px size
			e7.insert(0,Q6[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q6
		elif queueposition == 7:
			Q7 = pickle.load(open(name,"rb"))
			name = Q7[9] #filename
			e1.insert(0,Q7[4]) #blocksize
			e2.insert(0,Q7[0]) #startframe
			e3.insert(0,Q7[1]) #stopframe
			e4.insert(0,Q7[6]) #wormsize
			e6.insert(0,Q7[10]) #px size
			e7.insert(0,Q7[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q7
		elif queueposition == 8:
			Q8 = pickle.load(open(name,"rb"))
			name = Q8[9] #filename
			e1.insert(0,Q8[4]) #blocksize
			e2.insert(0,Q8[0]) #startframe
			e3.insert(0,Q8[1]) #stopframe
			e4.insert(0,Q8[6]) #wormsize
			e6.insert(0,Q8[10]) #px size
			e7.insert(0,Q8[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q8
		elif queueposition == 9:
			Q9 = pickle.load(open(name,"rb"))
			name = Q9[9] #filename
			e1.insert(0,Q9[4]) #blocksize
			e2.insert(0,Q9[0]) #startframe
			e3.insert(0,Q9[1]) #stopframe
			e4.insert(0,Q9[6]) #wormsize
			e6.insert(0,Q9[10]) #px size
			e7.insert(0,Q9[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q9
		elif queueposition == 10:
			Q10 = pickle.load(open(name,"rb"))
			name = Q10[9] #filename
			e1.insert(0,Q10[4]) #blocksize
			e2.insert(0,Q10[0]) #startframe
			e3.insert(0,Q10[1]) #stopframe
			e4.insert(0,Q10[6]) #wormsize
			e6.insert(0,Q10[10]) #px size
			e7.insert(0,Q10[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q10
		elif queueposition == 11:
			Q11 = pickle.load(open(name,"rb"))
			name = Q11[9] #filename
			e1.insert(0,Q11[4]) #blocksize
			e2.insert(0,Q11[0]) #startframe
			e3.insert(0,Q11[1]) #stopframe
			e4.insert(0,Q11[6]) #wormsize
			e6.insert(0,Q11[10]) #px size
			e7.insert(0,Q11[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q11
		elif queueposition == 12:
			Q12 = pickle.load(open(name,"rb"))
			name = Q12[9] #filename
			e1.insert(0,Q12[4]) #blocksize
			e2.insert(0,Q12[0]) #startframe
			e3.insert(0,Q12[1]) #stopframe
			e4.insert(0,Q12[6]) #wormsize
			e6.insert(0,Q12[10]) #px size
			e7.insert(0,Q12[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q12
		elif queueposition == 13:
			Q13 = pickle.load(open(name,"rb"))
			name = Q13[9] #filename
			e1.insert(0,Q13[4]) #blocksize
			e2.insert(0,Q13[0]) #startframe
			e3.insert(0,Q13[1]) #stopframe
			e4.insert(0,Q13[6]) #wormsize
			e6.insert(0,Q13[10]) #px size
			e7.insert(0,Q13[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q13
		elif queueposition == 14:
			Q14 = pickle.load(open(name,"rb"))
			name = Q14[9] #filename
			e1.insert(0,Q14[4]) #blocksize
			e2.insert(0,Q14[0]) #startframe
			e3.insert(0,Q14[1]) #stopframe
			e4.insert(0,Q14[6]) #wormsize
			e6.insert(0,Q14[10]) #px size
			e7.insert(0,Q14[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q14
		elif queueposition == 15:
			Q15 = pickle.load(open(name,"rb"))
			name = Q15[9] #filename
			e1.insert(0,Q15[4]) #blocksize
			e2.insert(0,Q15[0]) #startframe
			e3.insert(0,Q15[1]) #stopframe
			e4.insert(0,Q15[6]) #wormsize
			e6.insert(0,Q15[10]) #px size
			e7.insert(0,Q15[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q15
		elif queueposition == 16:
			Q16 = pickle.load(open(name,"rb"))
			name = Q16[9] #filename
			e1.insert(0,Q16[4]) #blocksize
			e2.insert(0,Q16[0]) #startframe
			e3.insert(0,Q16[1]) #stopframe
			e4.insert(0,Q16[6]) #wormsize
			e6.insert(0,Q16[10]) #px size
			e7.insert(0,Q16[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q16
		elif queueposition == 17:
			Q17 = pickle.load(open(name,"rb"))
			name = Q17[9] #filename
			e1.insert(0,Q17[4]) #blocksize
			e2.insert(0,Q17[0]) #startframe
			e3.insert(0,Q17[1]) #stopframe
			e4.insert(0,Q17[6]) #wormsize
			e6.insert(0,Q17[10]) #px size
			e7.insert(0,Q17[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q17
		elif queueposition == 18:
			Q18 = pickle.load(open(name,"rb"))
			name = Q18[9] #filename
			e1.insert(0,Q18[4]) #blocksize
			e2.insert(0,Q18[0]) #startframe
			e3.insert(0,Q18[1]) #stopframe
			e4.insert(0,Q18[6]) #wormsize
			e6.insert(0,Q18[10]) #px size
			e7.insert(0,Q18[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q18
		elif queueposition == 19:
			Q19 = pickle.load(open(name,"rb"))
			name = Q19[9] #filename
			e1.insert(0,Q19[4]) #blocksize
			e2.insert(0,Q19[0]) #startframe
			e3.insert(0,Q19[1]) #stopframe
			e4.insert(0,Q19[6]) #wormsize
			e6.insert(0,Q19[10]) #px size
			e7.insert(0,Q19[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q19
		elif queueposition == 20:
			Q20 = pickle.load(open(name,"rb"))
			name = Q20[9] #filename
			e1.insert(0,Q20[4]) #blocksize
			e2.insert(0,Q20[0]) #startframe
			e3.insert(0,Q20[1]) #stopframe
			e4.insert(0,Q20[6]) #wormsize
			e6.insert(0,Q20[10]) #px size
			e7.insert(0,Q20[11]) #frame time
			Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time = Q20
				
		#name must be a tif --> if log is called twice
		name = sorted(glob.glob(directory + "/*.tif"))[0] #returns first .tif in dir
	
	else:
		isimport = 0
		#activate classic button order
		b2.configure(state=NORMAL)
		#disable buttons
		b8.configure(state=DISABLED)
		b4.configure(state=DISABLED)
		b6.configure(state=DISABLED)
		b7.configure(state=DISABLED)
		b5.configure(state=DISABLED)
		
		#add max number of pictures in lastframe box
		filecount = len(glob.glob(directory + "/*.tif"))
		e3.delete(0,END)
		e3.insert(0,filecount)
		
	#---try to make filenames look nice
	try:
		testname = os.path.basename(directory)
		testnamedate = str(testname[4:6]) + "." + str(testname[2:4]) + ".20" + str(testname[0:2])
		splittestname = testname.split('_')
		testnamestrain = splittestname[1]
		testnamefield = splittestname[2]
		
		teststart = time.strftime("%H:%M:%S",(time.strptime(splittestname[4],"%I%M%S %p")))
		
		l1 = tk.Label(top,text=testnamestrain,padx=3,pady=3)
		l1.grid(row=1,column=8)
		l2 = tk.Label(top,text=testnamefield,padx=3,pady=3)
		l2.grid(row=2,column=8)
		l3 = tk.Label(top,text=testnamedate,padx=3,pady=3)
		l3.grid(row=3,column=8)		
		l4 = tk.Label(top,text=teststart,padx=3,pady=3)
		l4.grid(row=4,column=8)
	except:
		#print the current current directory in window
		l1 = tk.Label(top,text=(directory))
		l1.grid(row=1,column=8)#foldername

def onclick(event):
	#crop N E S W
	global c
	global pcrop
	global xclick
	global yclick
	
	if event.xdata != None and event.ydata != None:
		xclick = event.xdata
		yclick = event.ydata

	if c == 1:
		pcrop = []
		plt.axhline(y=yclick,linewidth=2,color='r')
		pcrop.append(int(yclick))
		c += 1
	elif c == 2:
		plt.axvline(x=xclick,linewidth=2,color='r')
		pcrop.append(int(im.shape[1]-xclick))
		c += 1	
	elif c == 3:
		plt.axhline(y=yclick,linewidth=2,color='r')
		pcrop.append(int(im.shape[0]-yclick))
		c += 1	
	elif c == 4:
		plt.axvline(x=xclick,linewidth=2,color='r')
		pcrop.append(int(xclick))
		c += 1
	elif c > 4:
		c = 0
		plt.close()
		
	#print("crop:",pcrop,"pic shape:",im.shape[0],im.shape[1])
	plt.draw()

def getnose(event):
	
	global noseposition
	
	if event.xdata != None and event.ydata != None:
		xclick = event.xdata
		yclick = event.ydata
		
		noseposition.append(int(yclick))
		noseposition.append(int(xclick))
	else:
		print("\nClicked outside plot window! Must repeat manual nose!")

	plt.close()

def drawwurm(): #for cropping
	global c
	global im
	c = 1
	im = plt.imread(name)

	#bestes ergebnis
	img_adapteq = exposure.equalize_hist(im)

	title("Only use this order for the borders: North East South West")
	implot = plt.imshow(img_adapteq,cmap='binary')
	axis('off')
	
	cid = implot.figure.canvas.mpl_connect('button_press_event', onclick)
	
	#activate buttons:
	b7.configure(state=NORMAL)
	
	#disable buttons:
	b5.configure(state=DISABLED)
	b5.configure(relief=RAISED)
	b6.configure(state=DISABLED)
	b8.configure(state=DISABLED)
	b9.configure(state=DISABLED)
	b9.configure(relief=RAISED)
	b10.configure(state=DISABLED)
	
	#adjust plotsize and draw graphs
	subplots_adjust(left=0.015, bottom=0.015, right=0.985, top=0.95, wspace=0.07, hspace=0.1)
	show()
	
def drawsize(): #for size estimation
	global Gwormsize
	Gwormsize = int(e4.get())
	
	#read images
	im = scipy.misc.imread(name)
	im = img_as_float(im)
	
	#if more frames should be displayed:
	if moreFrames == 1:
		#create list of all filenames
		picturelist = glob.glob(directory + "/*")

		im2 = scipy.misc.imread(picturelist[-1]) #get last file in list
		im2 = img_as_float(im2)
		
		im3 = scipy.misc.imread(picturelist[round(len(picturelist)/2)]) #get file in the middle of list
		im3 = img_as_float(im3)
	
	if isimport == False:
		#Apply Mask and plot +- 25%
		im[completeedge == False] = im.max()
		
		#if more frames should be displayed:
		if moreFrames == 1:
			im2[completeedge == False] = im2.max()
			im3[completeedge == False] = im3.max()
	else:
		#Apply Mask and plot +- 25%
		im[bestedge == False] = im.max()
		
		#if more frames should be displayed:
		if moreFrames == 1:
			im2[bestedge == False] = im2.max()
			im3[bestedge == False] = im3.max()

	#original image
	a,b,sizeim,c = nt.getthreshold(im,Gwormsize)
	a,b,sizeimA,c = nt.getthreshold(im,Gwormsize*0.75)
	a,b,sizeimB,c = nt.getthreshold(im,Gwormsize*1.25)
	
	#if more frames should be displayed:
	if moreFrames == 1:
		#last image
		a,b,sizeim2,c = nt.getthreshold(im2,Gwormsize)
		a,b,sizeim2A,c = nt.getthreshold(im2,Gwormsize*0.75)
		a,b,sizeim2B,c = nt.getthreshold(im2,Gwormsize*1.25)

		#middle image
		a,b,sizeim3,c = nt.getthreshold(im3,Gwormsize)
		a,b,sizeim3A,c = nt.getthreshold(im3,Gwormsize*0.75)
		a,b,sizeim3B,c = nt.getthreshold(im3,Gwormsize*1.25)


	#original image plots
	subplot(1,3,1)
	if moreFrames == 1:
		subplot(3,3,1)
	axis('off')
	temp_title = "-25%: " + str(Gwormsize*0.75)
	title(temp_title)
	imshow(sizeimA,cmap='binary')
	
	subplot(1,3,2)
	if moreFrames == 1:
		subplot(3,3,2)
	axis('off')
	title(Gwormsize)
	imshow(sizeim,cmap='binary')

	subplot(1,3,3)
	if moreFrames == 1:
		subplot(3,3,3)
	axis('off')
	temp_title = "+25%: " + str(Gwormsize*1.25)
	title(temp_title)
	imshow(sizeimB,cmap='binary')

	#if more frames should be displayed:
	if moreFrames == 1:
		#last image plots
		subplot(3,3,4)
		axis('off')
		temp_title = "-25%: " + str(Gwormsize*0.75) + " frame: " + str(len(picturelist) + 1)
		title(temp_title)
		imshow(sizeim2A,cmap='binary')
		
		subplot(3,3,5)
		axis('off')
		temp_title = str(Gwormsize) + " frame: " + str(len(picturelist))
		title(temp_title)
		imshow(sizeim2,cmap='binary')

		subplot(3,3,6)
		axis('off')
		temp_title = "+25%: " + str(Gwormsize*1.25) + " frame: " + str(len(picturelist) + 1)
		title(temp_title)
		imshow(sizeim2B,cmap='binary')
		
		#middle image plots
		subplot(3,3,7)
		axis('off')
		temp_title = "-25%: " + str(Gwormsize*0.75) + " frame: " + str(round(len(picturelist)/2))
		title(temp_title)
		imshow(sizeim3A,cmap='binary')
		
		subplot(3,3,8)
		axis('off')
		temp_title = str(Gwormsize) + "frame: " + str(round(len(picturelist)/2))
		title(temp_title)
		imshow(sizeim3,cmap='binary')

		subplot(3,3,9)
		axis('off')
		temp_title = "+25%: " + str(Gwormsize*1.25) + " frame: " + str(round(len(picturelist)/2))
		title(temp_title)
		imshow(sizeim3B,cmap='binary')


	#adjust plotsize and draw graphs
	subplots_adjust(left=0.015, bottom=0.015, right=0.985, top=0.95, wspace=0.07, hspace=0.1)
	show()
	
def setblocks():
	#sets blocksize, first/last frame
	global Gblocksize
	global Gfirstframe
	global Glastframe
	global Gwormsize
	Gwormsize = int(e4.get())
	Gblocksize = int(e1.get())
	Gfirstframe = int(e2.get())
	Glastframe = int(e3.get())
	
	if Glastframe > filecount:
		Glastframe = filecount
		e3.delete(0,END)
		e3.insert(0,filecount)
	top.update()
	
	#buttons
	b5.configure(relief=SUNKEN)
	b9.configure(state=NORMAL)
	b9.configure(relief=RAISED)
	b10.configure(state=DISABLED)
	
def edgecalc():
	global bestedge
	global avgEdge
	global completeedge
	
	#make #frames failproof
	avgFrames = int(e5.get())
	
	if avgFrames > filecount:
		avgFrames = filecount
		e5.delete(0,END)
		e5.insert(0,filecount)
	top.update()
	
	#choose method
	if Eassist.get() == 0:
		print("canny")
		bestedge,avgEdge = edgeassist_canny(0,avgFrames)
	else:
		print("otsu")
		bestedge,avgEdge = edgeassist_otsu(0,avgFrames)
		
	print("Done!")
	
	#create mask from manual crop
	wurm = scipy.misc.imread(name)
	
	cropmaskarray = np.zeros((wurm.shape[0],wurm.shape[1]))
	cropmaskarray[pcrop[0]:-pcrop[2],pcrop[3]:-pcrop[1]] = 1
	
	#calculate the complete edge: edgeassist + crop
	completeedge = bestedge
	completeedge[cropmaskarray == False] = 0
	
	#deactivate buttons
	b10.configure(state=DISABLED)
	b9.configure(relief=RAISED)
	
	#activate buttons
	b5.configure(state=NORMAL)
	b6.configure(state=NORMAL)
	b8.configure(state=NORMAL)

def edgeassist_canny(startframe,stopframe):
	#calculates the average edge on the agar based on canny edge detection
	
	#read all filenames into array
	filenames = sorted(glob.glob(directory + "/*.tif"))
	
	#get image dimensions, create empty mask
	tempim = scipy.misc.imread(filenames[0])
	masksum = np.zeros((tempim.shape))
	
	#get edges of all images and add them
	for i in range(startframe,stopframe+1):
		#print("processing file:",i+1,end="\r")
		progressbar(i,stopframe-startframe,title="Edge-assist:",progress_character="=",bar_size=20)
		
		im = scipy.misc.imread(filenames[i])
		
		ima = exposure.equalize_hist(im)
		
		imcanny = feature.canny(ima, sigma=4)
		
		mask = convex_hull_image(imcanny)
		
		masksum = masksum + mask
	
	#get the edge of the average masks
	maskedge = feature.canny(masksum, sigma=3)

	#create mask from averages
	convexmaskedge = convex_hull_image(maskedge)
	
	return(convexmaskedge,masksum)
	
def edgeassist_otsu(startframe,stopframe):
	#calculates the average edge on the agar based on otsu thresholding
	
	#read all filenames into array
	filenames = sorted(glob.glob(directory + "/*.tif"))
	
	#get image dimensions, create empty mask
	tempim = scipy.misc.imread(filenames[0])
	masksum = np.zeros((tempim.shape))
 
	#get edges of all images and add them
	for i in range(startframe,stopframe+1):
		#print("processing file:",i+1,end="\r")
		progressbar(i,stopframe-startframe,title="Edge-assist:",progress_character="=",bar_size=20)
		
		im = scipy.misc.imread(filenames[i])
		
		thresh = threshold_otsu(im)
		
		imcanny = feature.canny(im>thresh, sigma=1)
		
		mask = convex_hull_image(imcanny)
		
		masksum = masksum + mask
	
	#get the edge of the average masks
	maskedge = feature.canny(masksum, sigma=3)

	#create mask from averages
	convexmaskedge = convex_hull_image(maskedge)
	
	return(convexmaskedge,masksum)

def ShowCrop():
	
	wurm = scipy.misc.imread(name)
	
	if isimport == True:
		#print plots we actually know
		edgewurm = wurm.copy()
		edgewurm[bestedge == False] = edgewurm.min()
		
		subplot(1,1,1)
		axis('off')
		title("original picture + crop")
		imshow(edgewurm,cmap='binary')
		
	else:
		#draw plots of edgeassist
		subplot(2,2,1)
		axis('off')
		title("superimposed crop")
		imshow(avgEdge,cmap='binary')
		
		subplot(2,2,2)
		axis('off')
		title("optical average of crops")
		imshow(bestedge,cmap='binary')
		
		subplot(2,2,3)
		axis('off')
		title("original picture")
		imshow(wurm,cmap='binary')
		
		#create mask from manual crop
		cropmaskarray = np.zeros((wurm.shape[0],wurm.shape[1]))
		cropmaskarray[pcrop[0]:-pcrop[2],pcrop[3]:-pcrop[1]] = 1
		
		#now apply masks to image
		edgewurm = wurm.copy()
		edgewurm[completeedge == False] = edgewurm.min()
		
		subplot(2,2,4)
		axis('off')
		title("original picture + crop")
		imshow(edgewurm,cmap='binary')


	#adjust plotsize and draw graphs
	subplots_adjust(left=0.015, bottom=0.015, right=0.985, top=0.95, wspace=0.07, hspace=0.1)
	show()
	
def manualnose():
	global blockchange
	global newdirectory
	global noseposition
	global newnose
	
	newnose = 1
	noseposition = []
	
	#activate buttons
	b7.configure(state=NORMAL)
	b10.configure(state=NORMAL)
	
	#---- rename files ----
	filenames = sorted(glob.glob(directory + "/*.tif"))
	
	newdirectory = directory + '/NoseTracker'
	
	try:
		os.stat(newdirectory)
	except:
		os.mkdir(newdirectory)
	
	for i in range(Gfirstframe,Glastframe + 1): ##-1 #from 1 to 480 (480 files)
		c = i
		newname = "/%05d.tif" % c
		
		progressbar(i,(Glastframe-Gfirstframe)-1,progress_character="=",title="Converting:")
		
		#16-bit conversion
		shutil.copy2(filenames[i - 1], newdirectory + newname) #i-1 to account for 0 index
	
	#---- calculate at which frames a new block begins -----------------
	blockchange = list(nt.xfrange(1,filecount + 1,Gblocksize)) #list where burst mode ends, adjust for exlusive upper boundary
	#remove all frames we do not use
	blockchange = [i for i in blockchange if i < Glastframe and i >= Gfirstframe]
	
	#add first frame to blockchange if not already present for manual nose
	if Gfirstframe not in blockchange:
		blockchange.insert(0,Gfirstframe) 
	
	#---- draw all frames
	for i in range(0,len(blockchange)):
	
		c = blockchange[i]
		manualfile = "/%05d.tif" % c
		manualframe = newdirectory + manualfile
		
		im = plt.imread(manualframe)
		
		im = nt.crop(im,pcrop[0],pcrop[1],pcrop[2],pcrop[3])
		
		#2 - bestes ergebnis
		img_adapteq = exposure.equalize_hist(im)
		
		title("Click near the nose")
		implot2 = plt.imshow(img_adapteq,cmap='binary')
		axis('off')
		
		cid2 = implot2.figure.canvas.mpl_connect('button_press_event', getnose)
		
		#no progressbar if only one block
		if len(blockchange) > 1:
			progressbar(i,len(blockchange)-1)
		
		subplots_adjust(left=0.015, bottom=0.015, right=0.985, top=0.95, wspace=0.07, hspace=0.1)
		show()
		
	#buttons
	b9.configure(relief=SUNKEN)

def enqueue():
	global queueposition
	global Q1
	global Q2
	global Q3
	global Q4
	global Q5
	global Q6
	global Q7
	global Q8
	global Q9
	global Q10
	global Q11
	global Q12
	global Q13
	global Q14
	global Q15
	global Q16
	global Q17
	global Q18
	global Q19
	global Q20
	global isimport
	global newnose
	global startnoseposition
	global newdirectory
	#activate Buttons
	b4.configure(state=NORMAL) #Start button
	b13.configure(state=NORMAL) #Centroid Button
	b11.configure(state=NORMAL) #show queue
	
	#read sizes
	px_size = float(e6.get())
	frame_time = float(e7.get())
	
	print("-----------------------------------------------------------------------")
	print(directory)
	print("Added to Queue!")
	print("-----------------------------------------------------------------------")
	
	#--- create array with framenumber and position
	
	if isimport == False:
		startnoseposition = np.zeros((len(noseposition)/2)*3)
		startnoseposition[::3] = blockchange #every third value is blockchange starting with first value
		startnoseposition[1::3] = noseposition[::2] #y-values
		startnoseposition[2::3] = noseposition[1::2] #x-values
	else:
		#---- set startnoseposition if blocks are changed
		if newnose == 1:
			startnoseposition = np.zeros((len(noseposition)/2)*3)
			startnoseposition[::3] = blockchange #every third value is blockchange starting with first value
			startnoseposition[1::3] = noseposition[::2] #y-values
			startnoseposition[2::3] = noseposition[1::2] #x-values
		
		#---- rename files ----
		filenames = sorted(glob.glob(directory + "/*.tif"))
		newdirectory = directory + '/NoseTracker'
		
		try:
			os.stat(newdirectory)
		except:
			os.mkdir(newdirectory)
		
		for i in range(Gfirstframe,Glastframe + 1):
			c = i
			newname = "/%05d.tif" % c
			progressbar(i,(Glastframe-Gfirstframe)-1,progress_character="=",title="Converting:")
			#16-bit conversion
			shutil.copy2(filenames[i - 1], newdirectory + newname)
	
	#get wormsize
	Gwormsize = int(e4.get())
	
	#---assign gathered values to queuepositions
	if queueposition == 1:
		Q1 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q1,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 2:
		Q2 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q2,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 3:
		Q3 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q3,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 4:
		Q4 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q4,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 5:
		Q5 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q5,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 6:
		Q6 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q6,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 7:
		Q7 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q7,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 8:
		Q8 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q8,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 9:
		Q9 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q9,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 10:
		Q10 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q10,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 11:
		Q11 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q11,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 12:
		Q12 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q12,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 13:
		Q13 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q13,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 14:
		Q14 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q14,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 15:
		Q15 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q15,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 16:
		Q16 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q16,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 17:
		Q17 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q17,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 18:
		Q18 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q18,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 19:
		Q19 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q19,open(directory + "/00_NT_saved_settings.p","wb"))
	elif queueposition == 20:
		Q20 = [Gfirstframe,Glastframe,pcrop,newdirectory,Gblocksize,filecount,Gwormsize,bestedge,startnoseposition,name,px_size,frame_time]
		pickle.dump(Q20,open(directory + "/00_NT_saved_settings.p","wb"))
		print("Queue is full!")
		b3.configure(state=DISABLED) #disable folder select button if queue is full
	
	#---increase counter
	queueposition += 1
	isimport = 0
	
	#---reset all buttons
	b2.configure(state=DISABLED)
	b6.configure(state=DISABLED)
	b5.configure(state=DISABLED)
	b5.configure(relief=RAISED)
	b7.configure(state=DISABLED)
	b8.configure(state=DISABLED)
	b9.configure(state=DISABLED)
	b9.configure(relief=RAISED)
	b10.configure(state=DISABLED)
	
def showqueue():
	frametotal = 0
	#---show interesting values
	
	print("--------------------------------- QUEUE -------------------------------")
	
	if queueposition >= 2:
		print("directory:",Q1[3])
		print("Calculating Frame:",Q1[0],"to",Q1[1],"Wormsize:",Q1[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q1[1]-Q1[0] + 1
	if queueposition >= 3:
		print("directory:",Q2[3])
		print("Calculating Frame:",Q2[0],"to",Q2[1],"Wormsize:",Q2[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q2[1]-Q2[0] + 1
	if queueposition >= 4:
		print("directory:",Q3[3])
		print("Calculating Frame:",Q3[0],"to",Q3[1],"Wormsize:",Q3[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q3[1]-Q3[0] + 1
	if queueposition >= 5:
		print("directory:",Q4[3])
		print("Calculating Frame:",Q4[0],"to",Q4[1],"Wormsize:",Q4[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q4[1]-Q4[0] + 1
	if queueposition >= 6:
		print("directory:",Q5[3])
		print("Calculating Frame:",Q5[0],"to",Q5[1],"Wormsize:",Q5[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q5[1]-Q5[0] + 1
	if queueposition >= 7:
		print("directory:",Q6[3])
		print("Calculating Frame:",Q6[0],"to",Q6[1],"Wormsize:",Q6[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q6[1]-Q6[0] + 1
	if queueposition >= 8:
		print("directory:",Q7[3])
		print("Calculating Frame:",Q7[0],"to",Q7[1],"Wormsize:",Q7[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q7[1]-Q7[0] + 1
	if queueposition >= 9:
		print("directory:",Q8[3])
		print("Calculating Frame:",Q8[0],"to",Q8[1],"Wormsize:",Q8[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q8[1]-Q8[0] + 1
	if queueposition >= 10:
		print("directory:",Q9[3])
		print("Calculating Frame:",Q9[0],"to",Q9[1],"Wormsize:",Q9[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q9[1]-Q9[0] + 1
	if queueposition >= 11:
		print("directory:",Q10[3])
		print("Calculating Frame:",Q10[0],"to",Q10[1],"Wormsize:",Q10[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q10[1]-Q10[0] + 1
	if queueposition >= 12:
		print("directory:",Q11[3])
		print("Calculating Frame:",Q11[0],"to",Q11[1],"Wormsize:",Q11[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q11[1]-Q11[0] + 1
	if queueposition >= 13:
		print("directory:",Q12[3])
		print("Calculating Frame:",Q12[0],"to",Q12[1],"Wormsize:",Q12[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q12[1]-Q12[0] + 1
	if queueposition >= 14:
		print("directory:",Q13[3])
		print("Calculating Frame:",Q13[0],"to",Q13[1],"Wormsize:",Q13[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q13[1]-Q13[0] + 1
	if queueposition >= 15:
		print("directory:",Q14[3])
		print("Calculating Frame:",Q14[0],"to",Q14[1],"Wormsize:",Q14[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q14[1]-Q14[0] + 1
	if queueposition >= 16:
		print("directory:",Q15[3])
		print("Calculating Frame:",Q15[0],"to",Q15[1],"Wormsize:",Q15[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q15[1]-Q15[0] + 1
	if queueposition >= 17:
		print("directory:",Q16[3])
		print("Calculating Frame:",Q16[0],"to",Q16[1],"Wormsize:",Q16[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q16[1]-Q16[0] + 1
	if queueposition >= 18:
		print("directory:",Q17[3])
		print("Calculating Frame:",Q17[0],"to",Q17[1],"Wormsize:",Q17[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q17[1]-Q17[0] + 1
	if queueposition >= 19:
		print("directory:",Q18[3])
		print("Calculating Frame:",Q18[0],"to",Q18[1],"Wormsize:",Q18[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q18[1]-Q18[0] + 1
	if queueposition >= 20:
		print("directory:",Q19[3])
		print("Calculating Frame:",Q19[0],"to",Q19[1],"Wormsize:",Q19[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q19[1]-Q19[0] + 1
	if queueposition >= 21:
		print("directory:",Q20[3])
		print("Calculating Frame:",Q20[0],"to",Q20[1],"Wormsize:",Q20[6])
		print("-----------------------------------------------------------------------")
		frametotal += Q20[1]-Q20[0] + 1
	
	print("Total number of frames:",frametotal)
	print("Estimated time Nosetracker:","%.1f" %(frametotal/ntc.nt_currentfpm),"min.")
	print("Estimated time Centroidtracker:","%.1f" %(frametotal/ntc.ct_currentfpm),"min.")

def toggleFrames():
	#button to show 6 more frames in draw for size
	global moreFrames
	
	if b12.config('relief')[-1] == 'sunken':
		b12.config(relief = "raised")
		moreFrames = 0
	else:
		b12.config(relief = "sunken")
		moreFrames = 1

def centroidonly():
	##### Master button, starts the calcualtions #####
	GGlobaltime = time.time()
	#activate buttons
	b5.configure(relief=RAISED)

	#calculate for all queuepositions
	if queueposition == 1:
		print("Add something to the Queue!")
	if queueposition >= 2:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 2
		ct.wurmstart(Q1[0],Q1[1],Q1[2],Q1[3],Q1[4],Q1[5],Q1[6],Q1[7],GGlobaltime,queueposition,c_queueposition,Q1[10],Q1[11])
	if queueposition >= 3:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 3
		ct.wurmstart(Q2[0],Q2[1],Q2[2],Q2[3],Q2[4],Q2[5],Q2[6],Q2[7],GGlobaltime,queueposition,c_queueposition,Q2[10],Q2[11])
	if queueposition >= 4:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 4
		ct.wurmstart(Q3[0],Q3[1],Q3[2],Q3[3],Q3[4],Q3[5],Q3[6],Q3[7],GGlobaltime,queueposition,c_queueposition,Q3[10],Q3[11])
	if queueposition >= 5:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 5
		ct.wurmstart(Q4[0],Q4[1],Q4[2],Q4[3],Q4[4],Q4[5],Q4[6],Q4[7],GGlobaltime,queueposition,c_queueposition,Q4[10],Q4[11])
	if queueposition >= 6:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 6
		ct.wurmstart(Q5[0],Q5[1],Q5[2],Q5[3],Q5[4],Q5[5],Q5[6],Q5[7],GGlobaltime,queueposition,c_queueposition,Q5[10],Q5[11])
	if queueposition >= 7:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 7
		ct.wurmstart(Q6[0],Q6[1],Q6[2],Q6[3],Q6[4],Q6[5],Q6[6],Q6[7],GGlobaltime,queueposition,c_queueposition,Q6[10],Q6[11])
	if queueposition >= 8:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 8
		ct.wurmstart(Q7[0],Q7[1],Q7[2],Q7[3],Q7[4],Q7[5],Q7[6],Q7[7],GGlobaltime,queueposition,c_queueposition,Q7[10],Q7[11])
	if queueposition >= 9:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 9
		ct.wurmstart(Q8[0],Q8[1],Q8[2],Q8[3],Q8[4],Q8[5],Q8[6],Q8[7],GGlobaltime,queueposition,c_queueposition,Q8[10],Q8[11])
	if queueposition >= 10:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 10
		ct.wurmstart(Q9[0],Q9[1],Q9[2],Q9[3],Q9[4],Q9[5],Q9[6],Q9[7],GGlobaltime,queueposition,c_queueposition,Q9[10],Q9[11])
	if queueposition >= 11:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 11
		ct.wurmstart(Q10[0],Q10[1],Q10[2],Q10[3],Q10[4],Q10[5],Q10[6],Q10[7],GGlobaltime,queueposition,c_queueposition,Q10[10],Q10[11])
	if queueposition >= 12:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 12
		ct.wurmstart(Q11[0],Q11[1],Q11[2],Q11[3],Q11[4],Q11[5],Q11[6],Q11[7],GGlobaltime,queueposition,c_queueposition,Q11[10],Q11[11])
	if queueposition >= 13:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 13
		ct.wurmstart(Q12[0],Q12[1],Q12[2],Q12[3],Q12[4],Q12[5],Q12[6],Q12[7],GGlobaltime,queueposition,c_queueposition,Q12[10],Q12[11])
	if queueposition >= 14:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 14
		ct.wurmstart(Q13[0],Q13[1],Q13[2],Q13[3],Q13[4],Q13[5],Q13[6],Q13[7],GGlobaltime,queueposition,c_queueposition,Q13[10],Q13[11])
	if queueposition >= 15:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 15
		ct.wurmstart(Q14[0],Q14[1],Q14[2],Q14[3],Q14[4],Q14[5],Q14[6],Q14[7],GGlobaltime,queueposition,c_queueposition,Q14[10],Q14[11])
	if queueposition >= 16:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 16
		ct.wurmstart(Q15[0],Q15[1],Q15[2],Q15[3],Q15[4],Q15[5],Q15[6],Q15[7],GGlobaltime,queueposition,c_queueposition,Q15[10],Q15[11])
	if queueposition >= 17:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 17
		ct.wurmstart(Q16[0],Q16[1],Q16[2],Q16[3],Q16[4],Q16[5],Q16[6],Q16[7],GGlobaltime,queueposition,c_queueposition,Q16[10],Q16[11])
	if queueposition >= 18:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 18
		ct.wurmstart(Q17[0],Q17[1],Q17[2],Q17[3],Q17[4],Q17[5],Q17[6],Q17[7],GGlobaltime,queueposition,c_queueposition,Q17[10],Q17[11])
	if queueposition >= 19:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 19
		ct.wurmstart(Q18[0],Q18[1],Q18[2],Q18[3],Q18[4],Q18[5],Q18[6],Q18[7],GGlobaltime,queueposition,c_queueposition,Q18[10],Q18[11])
	if queueposition >= 20:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 20
		ct.wurmstart(Q19[0],Q19[1],Q19[2],Q19[3],Q19[4],Q19[5],Q19[6],Q19[7],GGlobaltime,queueposition,c_queueposition,Q19[10],Q19[11])
	if queueposition >= 21:
		print("\n"*23,"\033[23A",sep="")
		c_queueposition = 3
		ct.wurmstart(Q20[0],Q20[1],Q20[2],Q20[3],Q20[4],Q20[5],Q20[6],Q20[7],GGlobaltime,queueposition,c_queueposition,Q20[10],Q20[11])
	
def progressbar(current_progress,total_items,bar_size=50,left_limit="[",right_limit="]",title="Progress:",progress_character="#",empty_character="-"):
	
	scaling_factor = bar_size/total_items
	if current_progress <= total_items:
		print(title,left_limit,progress_character*math.ceil(current_progress*scaling_factor),empty_character*(bar_size-math.ceil(current_progress*scaling_factor)),right_limit," ",math.ceil(((current_progress)/total_items)*100),"%",sep="",end="\r")
	if current_progress == total_items:
		print("",sep="")

#if __name__ == '__main__':

#turn off cursor
os.system('setterm -cursor off')

top = tk.Tk()
top.wm_title("Nosetracker - " + ntc.myname)
top.minsize(700,75)
Eassist = tk.IntVar()

#---first row
b3 = tk.Button(top, text="Select File/Folder", width = 15, command=getdir)
b2 = tk.Button(top, text="Crop Image",width = 15, state=DISABLED, command=drawwurm)
b6 = tk.Button(top, text="Show Wormsize",width = 15, state=DISABLED, command=drawsize)
l2 = tk.Label(top,text="Sample:")

#---second row
b5 = tk.Button(top, text="Set Blocksize:", width = 15, state=DISABLED, command=setblocks)
e1 = tk.Entry(top,width=6,justify=RIGHT)
e1.insert(0,ntc.set_blocksize)
l4 = tk.Label(top,text="Frames:")
e2 = tk.Entry(top,width=6,justify=RIGHT)
e2.insert(0,"1")
l5 = tk.Label(top,text="to")
e3 = tk.Entry(top,width=6,justify=RIGHT)
l6 = tk.Label(top,text="Target Wormsize:")
e4 = tk.Entry(top,width=6,justify=RIGHT)
e4.insert(0,ntc.set_target_wormsize)

#---third row
b7 = tk.Button(top, text="Edge Assist", width = 15, state=DISABLED, command=edgecalc)
l8 = tk.Label(top,text="# Frames to avg.:")
e5 = tk.Entry(top,width=6,justify=RIGHT)
e5.insert(0,ntc.set_assist_frames)
l9 = tk.Label(top,text="Method:")
r1 = tk.Radiobutton(top, text="Canny", variable=Eassist, value=0, indicatoron=0,padx=10,pady=3)
r2 = tk.Radiobutton(top, text="Otsu", variable=Eassist, value=1, indicatoron=0,padx=10,pady=3)
b8 = tk.Button(top, text="Show Crop",width=15, command=ShowCrop, state=DISABLED)
b12 = tk.Button(top, text="Show more Frames",width = 15,pady=3, command=toggleFrames)

#---fourth row
b4 = tk.Button(top, text="START!", width = 15, fg="#373", state=DISABLED, command=START)
l7 = tk.Label(top,text="V.3.1", justify=RIGHT, state=DISABLED) #<---------::::::::::::::::::::::::::::::::::::::::::::::::::::::::: Version
b9 = tk.Button(top, text="Manual Nose", width = 15, state=DISABLED, command=manualnose)
b10 = tk.Button(top, text="Add to Queue",width = 15, state=DISABLED, command=enqueue)
b11 = tk.Button(top,text="Show Queue",width = 15, state=DISABLED, command=showqueue)
b13 = tk.Button(top,text="START, Centroid Only!", width = 15, fg="#242" , state=DISABLED, command=centroidonly)

#-----
l10 = tk.Label(top,text="um per Pixel:")
e6 = tk.Entry(top,width=8,justify=RIGHT)
e6.insert(0,ntc.set_um)
l11 = tk.Label(top,text="Time per Frame:")
e7 = tk.Entry(top,width=8,justify=RIGHT)
e7.insert(0,ntc.set_time_per_frame)
l12 = tk.Label(top,text="Seconds")

#----------- GRID ------------------------

#---first row
b3.grid(row=1,column=1)#select folder
b2.grid(row=1,column=2)#draw for crop
l2.grid(row=1,column=7)#foldername


#---second row
b7.grid(row=2,column=1)#Edge Assist
l8.grid(row=2,column=2,sticky=E)#Num of frames to AVG
e5.grid(row=2,column=3,sticky=W)#Num of frames to AVG
l9.grid(row=2,column=4,sticky=E)#Method
r1.grid(row=2,column=5)#Canny
r2.grid(row=2,column=6)#Otsu
b8.grid(row=2,column=7)#Show crop

#---third row
l6.grid(row=3,column=2,sticky=E)#target wormsize
e4.grid(row=3,column=3,sticky=W)#target wsize entry
b6.grid(row=3,column=1)#drawsize button
b12.grid(row=3,column=4)#toggle more frames to be drawn

#---fourth row
b5.grid(row=4,column=1)#Set Blocks:
e1.grid(row=4,column=2,sticky=W)#entry for blocks
l4.grid(row=4,column=3,sticky=E)#Frame
e2.grid(row=4,column=4)#first frame
l5.grid(row=4,column=5)#Frame
e3.grid(row=4,column=6)#last frame

#---fifth row
l10.grid(row=5,column=2,sticky=E)#
e6.grid(row=5,column=3,sticky=W)#entry px speed
l11.grid(row=5,column=4,sticky=E)#
e7.grid(row=5,column=5,sticky=W)#entry frame time
l12.grid(row=5,column=6,sticky=W)

#---sixth row
b9.grid(row=6,column=1)#manual nose
b10.grid(row=6,column=2)#enqueue
b11.grid(row=6,column=3)#show queue

#---seventh row
b4.grid(row=7,column=1)#start
l7.grid(row=7,column=7)#version number
b13.grid(row=7,column=2)#only track centroid

top.mainloop()
