#Change config options here

########################################################################
# Personalize your wormtracker!
########################################################################

myname = "Nosetracker"

########################################################################
# GUI default settings
########################################################################

#Initial Directory for nosetracker
start_directory = "/home/Videos"

#Number of frames to average with Canny or Otsu assisted edge detection
set_assist_frames = "10"

#Target Wormsize
set_target_wormsize = "4700"

#Blocksize for GUI
set_blocksize = "5000"

#um per Pixel
set_um = "0.42"

#Time per Frame
set_time_per_frame = "0.5"


########################################################################
# Nosetracker and Centroid Tracker
########################################################################

#--- Adjust the number of parallel processes to fit the number of physical
#--- processors including hyperthreading.
#number of parallel processes for nosetracker
nt_parallel_processes = 2

#number of parallel processes for centroid tracker
ct_parallel_processes = 2

#--- Adjust this value to fit the speed of your hardware to get an estimate
#--- of the required processing time. fpm is shown at the end of the run.
#frames per minute for nosetracker
nt_currentfpm = 55

#frames per minute for centroidtracker
ct_currentfpm = 310

#Blocksize for Centroid Tracker, determines the blocks for multiprocessing,
#adjust to reduce processing time according to hardware
CT_blocksize = 20

#blocksize for quick analysis
block1 = 40
block2 = 40
block3 = 40

#scaling of the graphs, in um per pixel
y_minimum = 0
y_maximum = 100

#create a folder in the parent directory of the videos where all tracking
#data and/or plots are collected
#1 = yes
#0 = no
shared_folder = 1
shared_plots = 1

#method used for skeletonization, either skeletonization bei erosion or 
#by medial axis transformation (only relevant for nosetracker)
#0 = erosion
#1 = medial axis transformation
skeletonization_method = 1

########################################################################
#settings of the getthreshold() function

#--- The lower and upper limit set the percentage value of allowed deviation
#--- of the target wormsize. Since the function is monte carlo based, it
#--- will randomly check for better threshold values to match the targeted
#--- wormsize. The closer the match should be, the longer it takes.

#nosetracker (+-0.5%)
nt_lower_size_limit = 0.995

nt_upper_size_limit = 1.005

#centroidtracker (+-1%)
ct_lower_size_limit = 0.99

ct_upper_size_limit = 1.01

#maximum number of attempts the getthreshold function will make to find
#the matching threshhold
#averages around 20 attempts

max_attempts = 100

#set parameters for blurring of the image
# 0 = gauss blur
# 1 = bilateral blur
blur_method = 0

#for gauss filter, radius in pixels
gauss_radius = 1.5

#for bilateral filtering
bilateral_range = 0.05
bilateral_spatial = 15


########################################################################
# Debugging
########################################################################

#0 = print various values from within the functions
#1 = silent
silent = 1

#show plots from the tracker
# 0 = no plots
# 1 = show plots from each frame with intermediate steps
# 2 = conclusive plots (same as printed to pdf at the end)
showplots = 2
